#!/usr/koeki/bin/ruby
# -*- coding: utf-8 -*-

puts "ゲームを始める前に、あなたの名前を入力してね。"

while true
  print "名前 : "
  name = STDIN.gets.chomp!
  puts ""
  puts "--------------------------------------------------"
  puts "あなたの名前 : " + name
  puts "--------------------------------------------------"
  while true
    print "これでよろしいですか? (Yes = 1, No = 2): "
    ans = STDIN.gets.chomp!.to_i
    if ans == 1 || ans == 2 then
      break
    else
      puts "1 か 2 で入力してね"
    end
  end
  if ans == 1 then
    sleep(1)
    puts"それでは、ゲームスタート!"
    puts""
    break
  elsif ans == 2 then
    puts "もう一度最初から入力してね"
    redo
  end
end

########## プロローグ ##########
sleep(2)
puts"+------------------------------------------------+"
puts "とある世界に、勇者 #{name} が暮らしている「#{name}王国」があった。"
sleep(2)
puts "勇者 #{name} は王宮にいる姫のもとへ向かう途中だった。"
sleep(2)
puts "しかし、王宮にたどりついてみると・・・"
sleep(3)
puts "なんと！姫がさらわれていた！"
sleep(2)
puts "勇者 #{name} は姫を助け出すために旅にでるのであった・・・"

sleep(2)
puts"+------------------------------------------------+"
system 'banner KOEKI QUEST'
puts"+------------------------------------------------+"
sleep(3)
puts""
########## プロローグEND ############


########## 作ったゲームはここからいれてね ###########
puts"なんと!いきなりボスがあらわれた!"
sleep(2)
puts""
puts"コンピュータとじゃんけんをしよう!"
puts"5回中3回勝てればクリアだよ!"
sleep(5)
puts""
print"それじゃ GAME START\n"
puts""

win = 0
kaisuu = 1
janken = ["だしてないよー", "グー", "チョキ", "パー"]

while kaisuu <= 5
  sleep(2)
  puts""
  printf("%d回目!(あなたの勝利数:%d)\n", kaisuu, win)
  puts""
  print"じゃーんけーん!(グーなら「1」チョキなら「2」パーなら「3」を押してね): "
  while true
    you = gets.chomp.to_i
    com = rand(3) + 1
    printf("ぽん! (あなたは「%s」で コンピュータは「%s」)\n", janken[you], janken[com])
    sleep(1)
    if (you == 1 && com == 2) || (you == 2 && com == 3) || (you == 3 && com == 1)
      puts"あなたの勝ち!"
      win += 1
      kaisuu += 1
      break
    elsif (you == 1 && com == 3) || (you == 2 && com == 1) || (you == 3 && com == 2)
      puts"あなたの負け!"
      kaisuu += 1
      break
    elsif you == com
      print"あーいこーで(グーなら「1」チョキなら「2」パーなら「3」を押してね): "
      redo
    else
      puts"なにもだしてないからあなたの負け!"
      kaisuu += 1
      break
    end
  end
end

sleep(3)
printf("あなたの勝利数は「%d 回」\n", win)
sleep(3)

if win >= 3
  puts"おめでとう!ボスをたおしたよ!"
  sleep(1)
  print"+---------------[Quest Clear]---------------+"
  sleep(2)
  puts""
  puts""
  puts"...姫を助け出すことができた!..."
  sleep(2)
  puts""
  puts"...#{name}王国に再び平和が訪れた!!..."
  sleep(2)
  puts""
  puts"+-------------------------------------------------+"
  system 'banner YOU WIN!!'
  puts"+-------------------------------------------------+"
else
  puts"...ぜんめつしてしまった..."
  sleep(2)
  puts"+------------------------------------------------+\n"
  system 'banner GAME OVER'
  puts"+------------------------------------------------+\n"
end
